'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HistoryStub = exports.WindowStub = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _eventEmitter = require('event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WindowStub = exports.WindowStub = function WindowStub(initialPath) {
  (0, _classCallCheck3.default)(this, WindowStub);

  this.document = {
    location: {
      href: 'http://address/' + initialPath,
      pathname: initialPath,
      search: ''
    },

    referrer: 'http://referrer1',

    querySelector: function querySelector() {
      return true;
    }
  };
};

var HistoryStub = exports.HistoryStub = function () {
  function HistoryStub() {
    var _this = this;

    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [{ data: {}, title: null, hash: 'url' }];
    (0, _classCallCheck3.default)(this, HistoryStub);
    this.Adapter = {
      bind: function bind(scope, event, callback) {
        _this.historyEmitter.on('updateState', function () {
          return callback();
        });
      }
    };

    this.historyEmitter = new _eventEmitter2.default();
    this.position = state.length === 0 ? 0 : state.length - 1;
    this.state = [].concat((0, _toConsumableArray3.default)(state));
  }

  (0, _createClass3.default)(HistoryStub, [{
    key: 'getState',
    value: function getState() {
      return this.state[this.position];
    }
  }, {
    key: 'replaceState',
    value: function replaceState(data, title, href) {
      var _state$position = this.state[this.position],
          currentData = _state$position.data,
          currentTitle = _state$position.title,
          currentUrl = _state$position.hash;


      var newState = {
        data: data || currentData,
        title: title || currentTitle,
        hash: href || currentUrl
      };

      this.state = [].concat((0, _toConsumableArray3.default)(this.state.slice(0, this.position)), [newState]);

      this.historyEmitter.emit('updateState');
    }
  }, {
    key: 'pushState',
    value: function pushState(data, title, href) {
      var _state$position2 = this.state[this.position],
          currentData = _state$position2.data,
          currentTitle = _state$position2.title,
          currentUrl = _state$position2.hash;


      var newState = {
        data: data || currentData,
        title: title || currentTitle,
        hash: href || currentUrl
      };

      this.state = [].concat((0, _toConsumableArray3.default)(this.state.slice(0, this.position + 1)), [newState]);

      this.position = this.position + 1;
      this.historyEmitter.emit('updateState');
    }
  }, {
    key: 'back',
    value: function back() {
      this.position = this.position - 1;
      this.historyEmitter.emit('updateState');
    }
  }, {
    key: 'forward',
    value: function forward() {
      if (this.state[this.position + 1]) {
        this.position = this.position + 1;
        this.historyEmitter.emit('updateState');
      }
    }
  }]);
  return HistoryStub;
}();